### Method

# Camel CipherValidity add_certinfo_ex

since: 2.30

#### Declaration [src]

    gint
    camel_cipher_validity_add_certinfo_ex (
      CamelCipherValidity* vin,
      CamelCipherValidityMode mode,
      const gchar* name,
      const gchar* email,
      gpointer cert_data,
      GDestroyNotify cert_data_free,
      CamelCipherCloneFunc cert_data_clone
    )

#### Description [src]

Add a cert info to the signer or encrypter info, with extended data set.

Available since: 2.30

#### Parameters

`mode`

  Type: `CamelCipherValidityMode`

  A `CamelCipherValidityMode`, where to add the additional certificate information.

`name`

  Type: `const gchar*`

  A name to add.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`email`

  Type: `const gchar*`

  An e-mail address to add.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`cert_data`

  Type: `gpointer`

  A certificate data, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`cert_data_free`

  Type: `GDestroyNotify`

  A destroy function for `cert_data`; required, when `cert_data` is not `NULL`.

  The argument can be `NULL`.

`cert_data_clone`

  Type: `CamelCipherCloneFunc`

  A copy function for `cert_data`, to copy the data; required, when `cert_data` is not `NULL`.

  The argument can be `NULL`.

#### Return value

Type: `gint`

Index of the added certinfo; -1 on error.